/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.information.entity;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;

import com.jeeplus.common.utils.excel.annotation.ExcelField;
import com.jeeplus.core.persistence.DataEntity;

/**
 * 项目信息Entity
 * @author qiuyue
 * @version 2019-09-04
 */
public class Information extends DataEntity<Information>  {

	//项目定义号
	private String projectId;
//	项目名称
	private String projectName;
//	项目类型
	private String projectType;
//	电压等级
	private String projectGrade;
//	项目预算年度
	private String projectYear;
//	项目总投资（元）
	private Double projectTotal;
//	实际开工日期
	private Date projectStart;
//	实际竣工日期
	private Date projectStop;
//	施工单位
	private String department;
//	事务所名称
	private String projectFirm;
//	提交送审日期
	private Date subDate;
//	审计任务下达日期
	private Date releaseDate;
//	审计应结束日时间
	private Date endDate;
//	结果上传时间
	private Date resultDate;
//	审定日期
	private Date approvalDate;
//	二级单位
	private String secondUnits;
//	一级单位
	private String firstUnits;

	public Information(){
		super();
	}

	@ExcelField(title="项目定义号", align=2, sort=1)
	public String getProjectId() {
		return projectId;
	}

	public void setProjectId(String projectId) {
		this.projectId = projectId;
	}

	@ExcelField(title="项目名称", align=2, sort=2)
	public String getProjectName() {
		return projectName;
	}

	public void setProjectName(String projectName) {
		this.projectName = projectName;
	}

	public String getDepartment() {
		return department;
	}

	public void setDepartment(String department) {
		this.department = department;
	}

	@JsonFormat(pattern = "yyyy-MM-dd")
	public Date getApprovalDate() {
		return approvalDate;
	}

	@JsonFormat(pattern = "yyyy-MM-dd")
	public void setApprovalDate(Date approvalDate) {
		this.approvalDate = approvalDate;
	}

	public String getSecondUnits() {
		return secondUnits;
	}

	public void setSecondUnits(String secondUnits) {
		this.secondUnits = secondUnits;
	}

	public String getFirstUnits() {
		return firstUnits;
	}

	public void setFirstUnits(String firstUnits) {
		this.firstUnits = firstUnits;
	}

	public String getProjectType() {
		return projectType;
	}

	public void setProjectType(String projectType) {
		this.projectType = projectType;
	}

	public String getProjectGrade() {
		return projectGrade;
	}

	public void setProjectGrade(String projectGrade) {
		this.projectGrade = projectGrade;
	}

	public String getProjectYear() {
		return projectYear;
	}

	public void setProjectYear(String projectYear) {
		this.projectYear = projectYear;
	}

	public Double getProjectTotal() {
		return projectTotal;
	}

	public void setProjectTotal(Double projectTotal) {
		this.projectTotal = projectTotal;
	}
	@JsonFormat(pattern = "yyyy-MM-dd")
	public Date getProjectStart() {
		return projectStart;
	}
	@JsonFormat(pattern = "yyyy-MM-dd")
	public void setProjectStart(Date projectStart) {
		this.projectStart = projectStart;
	}
	@JsonFormat(pattern = "yyyy-MM-dd")
	public Date getProjectStop() {
		return projectStop;
	}
	@JsonFormat(pattern = "yyyy-MM-dd")
	public void setProjectStop(Date projectStop) {
		this.projectStop = projectStop;
	}

	public String getProjectFirm() {
		return projectFirm;
	}

	public void setProjectFirm(String projectFirm) {
		this.projectFirm = projectFirm;
	}
	@JsonFormat(pattern = "yyyy-MM-dd")
	public Date getSubDate() {
		return subDate;
	}

	public void setSubDate(Date subDate) {
		this.subDate = subDate;
	}
	@JsonFormat(pattern = "yyyy-MM-dd")
	public Date getReleaseDate() {
		return releaseDate;
	}

	public void setReleaseDate(Date releaseDate) {
		this.releaseDate = releaseDate;
	}
	@JsonFormat(pattern = "yyyy-MM-dd")
	public Date getEndDate() {
		return endDate;
	}

	public void setEndDate(Date endDate) {
		this.endDate = endDate;
	}
	@JsonFormat(pattern = "yyyy-MM-dd")
	public Date getResultDate() {
		return resultDate;
	}

	public void setResultDate(Date resultDate) {
		this.resultDate = resultDate;
	}

}