/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.information.service;

import java.util.List;

import com.jeeplus.modules.sg.information.entity.Information;
import com.jeeplus.modules.sg.information.mapper.InformationMapper;
import io.swagger.models.auth.In;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;

/**
 * 项目管理Service
 * @author
 * @version
 */
@Service
@Transactional(readOnly = true)
public class InformationService extends CrudService<InformationMapper, Information> {

	@Autowired
	private InformationMapper informationMapper;

	public Information get(String id) {
		Information information = super.get(id);
		return information;
	}

	public List<Information> findList(Information information) {
		return super.findList(information);
	}


	public List<Information> findAllList(Information entity) {
		return super.findAllList(entity);
	}

	public Page<Information> findPage(Page<Information> page, Information entity) {
		return super.findPage(page, entity);
	}

	@Override
	public List<Information> findListBy(List<Information> entity) {
		return super.findListBy(entity);
	}


/*	@Transactional(readOnly = false)
	public void insert(List<Information> entity) {
		for (int i = 0; i < entity.size(); i++) {
			if (entity.get(i).getIsNewRecord()) {
				entity.get(i).preInsert();
			}
		}
		informationMapper.save(entity);
	}*/

	public Information findListById(String projectId){
		return informationMapper.findListById(projectId);
	}

	@Transactional(readOnly = false)
	public void save(Information entity) {
		entity.preInsert();
		informationMapper.insert(entity);
	}

	@Transactional(readOnly = false)
	public int saveInfo(List<Information> entity) {
		return informationMapper.saveInfo(entity);
	}

	public int successCount() {
		return informationMapper.successCount();
	}

	public  List<Information> findAllInformationList() {
		return informationMapper.findAllInformationList();
	}

	@Transactional(readOnly = false)
	public int updateInformationDate(Information information) {
		return informationMapper.updateInformationDate(information);
	}

	public Information findInformationByID(Information information) {
		return informationMapper.findInformationByID(information);
	}
}