/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.material.service;

import java.util.List;

import com.jeeplus.modules.sg.material.entity.Material;
import com.jeeplus.modules.sg.material.mapper.MaterialMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;

/**
 * 项目管理Service
 * @author
 * @version
 */
@Service
@Transactional(readOnly = true)
public class MaterialService extends CrudService<MaterialMapper, Material> {

	@Autowired
	private MaterialMapper materialMapper;

	public Material get(String id) {
		Material material = super.get(id);
		return material;
	}

	public List<Material> findList(Material material) {
		return super.findList(material);
	}

	public Page<Material> findPage(Page<Material> page, Material entity) {
		return super.findPage(page, entity);
	}

	@Override
	public List<Material> findListBy(List<Material> entity) {
		return super.findListBy(entity);
	}

	@Transactional(readOnly = false)
	public void save(Material entity) {
		entity.preInsert();
		materialMapper.insert(entity);
	}
	/*
	@Transactional(readOnly = false)
	public void insert(List<Material> entity) {
		for (int i = 0; i < entity.size(); i++) {
			if (entity.get(i).getIsNewRecord()) {
				entity.get(i).preInsert();
			}
		}
		materialMapper.save(entity);
	}
*/

	@Transactional(readOnly = false)
	public void saveMater(List<Material> entity) {
		materialMapper.saveMater(entity);
	}

	public Material findByProIn(String projectId,String infoId) {
		return materialMapper.findByProIn(projectId, infoId);
	}

	@Transactional(readOnly = false)
	public Integer updateInfo(Material material) {
		return materialMapper.updateInfo(material);
	}

	public Material findByMaterialId(Material material){
		return materialMapper.findByMaterialId(material);
	}
}